#-------------------------------------------------------------------------------
# Name:        cachegrab
#-------------------------------------------------------------------------------
#!/usr/bin/env python






#-------------------------------------------------------------------------------
# imports we need
import sys
import os
import time
import hashlib
#import urllib
#from urllib import urlopen

import urllib2
from urllib2 import urlopen
#-------------------------------------------------------------------------------


#-------------------------------------------------------------------------------
# include top level directory (needed to import from helper below)
#curpath = os.path.dirname(os.path.realpath(__file__))
#parpath = os.path.normpath(os.path.join(curpath, "../.."))
#sys.path.append(parpath+"/core")

# import the helper classes
from TWLCHelper import *
#-------------------------------------------------------------------------------


#-------------------------------------------------------------------------------
# constants and defines
DEF_Default_CacheGrabBrowser_UserAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)"
#-------------------------------------------------------------------------------







#---------------------------------------------------------------------------
class TCacheGrab(object):

    def __init__(self):
        # create the TWLCHelper helper
        self.helper = TWLCHelper()
        # defaults
        self.set_cachevals("./cache",60)
        self.set_url("http://www.google.com")
        self.set_useragent(DEF_Default_CacheGrabBrowser_UserAgent)

    def __del__(self):
        pass


    def set_cachevals(self,incachedir,incacheminutes):
        self.cachedir=incachedir
        self.cacheminutes=incacheminutes

    def set_url(self,inurl):
        self.url=inurl

    def set_useragent(self,inuseragent):
        self.useragent=inuseragent


    def DoParseCommandline(self,comlineargs):
        # set usage
        self.helper.set_usage("sample usage: %prog [options] arg")
        # commandline options
        self.helper.get_parser().add_option("", "--url", dest="url", help="fetch the URL specified")
        self.helper.get_parser().add_option("", "--cachedir", dest="cachedir", help="directory where cache files are stored")
        self.helper.get_parser().add_option("", "--cacheminutes", dest="cacheminutes", help="number of minutes cache should last")
        # other commandline options
        self.helper.get_parser().add_option("", "--infile", dest="infile", help="input file (full path)")
        self.helper.get_parser().add_option("", "--outfile", dest="outfile", help="output file (full path), or defaults to stdout")
        # derived specific
        self.ParseDerivedCommandlineArgs()
        # ok parse some args from commandline
        self.helper.ParseCommandlineParameters(comlineargs)
        # open filein and fileout files (or stdio)
        self.helper.OpenIO()
        # ok get the url to fetch, or else error
        self.set_url(self.helper.get_arg("url","",True))
        # cachedir from commandline
        incachedir = self.helper.get_arg("cachedir",self.cachedir,False)
        incachedir = self.helper.FixupRelativeDirectories(incachedir,os.path.realpath(__file__))
        self.set_cachevals(incachedir,self.helper.get_arg_asint("cacheminutes",self.cacheminutes,False))


    def ParseDerivedCommandlineArgs(self):
        # parse any derived object specific commandline options
        pass


    def RunWithCommandlineOptions(self,comlineargs):
        # parse commandline using helper
        self.DoParseCommandline(comlineargs)
        retv = self.DoGrabUrl(self.url)
        return retv


    def CalculateCacheFilename(self,inurl):
        m = hashlib.md5()
        m.update(inurl)
        retv = (m.hexdigest()) + ".cachedfetch"
        return retv


    def GetFromCacheIfNewEnough(self,cachefilenamefull):
        if (self.CachedFileExistsAndIsRecent(cachefilenamefull)):
            cachefp=open(cachefilenamefull,"r")
            outlines=cachefp.readlines()
            return outlines
        return None

    def CachedFileExistsAndIsRecent(self,cachefilenamefull):
        if (self.cachedir!=""):
            if (os.path.isfile(cachefilenamefull)):
                filetime = os.path.getmtime(cachefilenamefull)
                diftime = time.time()-filetime
                #print "AGE OF CACHE IN SECONDS: "
                #print diftime
                #print "CASH MINUTES: "
                #print cacheminutes
                if (diftime>=0) and (diftime<self.cacheminutes*60):
                    # ok its new enough
                    return True
        return False


    def DoFetchOutput(self,inurl):
        headers = { 'User-Agent' : self.useragent }
        #print "HEADERS: "
        #print headers
        #print "inurl = "+inurl
        #outlines = ["inurl",inurl]
        #return outlines

        req = urllib2.Request(inurl, None, headers)
        urlfileobj = urlopen(req)
        outlines = urlfileobj.readlines()

        return outlines


    def DoGrabUrl(self,inurl):
        # store url in object
        self.url=inurl
        #
        cachefilename = self.CalculateCacheFilename(self.url)
        cachefilenamefull = self.cachedir + "/" + cachefilename
        #
        # ok now does cache file exist, AND is new enough, if so get from there
        outlines = self.GetFromCacheIfNewEnough(cachefilenamefull)

        if outlines == None:
            # ok not cached, so fetch it
            #print "URL IS " + self.url
            outlines = self.DoFetchOutput(self.url)

            # save to cache
            cachefp=open(cachefilenamefull,"w")
            cachefp.writelines(outlines)

        # now write to output
        # ATTN: not sure when writelines started failing -- i think its because of redirected io
        if (False):
            self.helper.get_fileout().writelines(outlines)
        else:
            fout = self.helper.get_fileout()
            for oneline in outlines:
                fout.write(oneline)

        # success
        return 0
#---------------------------------------------------------------------------













































#---------------------------------------------------------------------------
def main(comlineargs=None):
    # make cacegrab object
    cachegrabber = TCacheGrab()

    # and ask it to run with commandline options
    return cachegrabber.RunWithCommandlineOptions(comlineargs)
#---------------------------------------------------------------------------




#-------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#-------------------------------------------------------------------------------


