#-------------------------------------------------------------------------------
# Name:        postfilter
#-------------------------------------------------------------------------------
#!/usr/bin/env python






#-------------------------------------------------------------------------------
# imports we need
# include top level directory (needed to import from helper below)
import sys
import os
#-------------------------------------------------------------------------------



#-------------------------------------------------------------------------------
# add parent directory to path
curpath = os.path.dirname(os.path.realpath(__file__))
parpath = os.path.normpath(os.path.join(curpath, ".."))
sys.path.append(parpath)

# import the parent classes
from TProcess import *
#-------------------------------------------------------------------------------


















#---------------------------------------------------------------------------
class TPostFilter_AmazonAffiliate(TProcess):

    def __init__(self):
        # parent init
        super(TPostFilter_AmazonAffiliate, self).__init__()

    def __del__(self):
        pass


    def ParseDerivedCommandlineArgs(self):
        self.helper.get_parser().add_option("", "--tag", dest="tag", help="affiliate tag")


    def RunWithCommandlineOptions(self,comlineargs):
        # parse commandline using helper
        self.DoParseCommandline(comlineargs)
        # build extraargs
        extraargs = {}
        extraargs["tag"]=self.helper.get_arg("tag","",False)
        # run it
        retv = self.DoWork(self.helper.get_filein(),self.helper.get_fileout(),extraargs)
        return retv







    # overridden

    def DoProcessLineDict(self,linedict,extraargs):
        # manipulate the linedict in any way one wants
        # ok find url
        if "url" in linedict:
            url = linedict["url"]
            urll = url.lower()
            # IFF its amazon
            if urll.find("amazon.com/")>-1:
                # add tag
                url = url + "?tag="+extraargs["tag"]
                linedict["url"]=url

        return linedict
#---------------------------------------------------------------------------

















































#---------------------------------------------------------------------------
def main(comlineargs=None):
    # make object
    postfilter = TPostFilter_AmazonAffiliate()

    # and ask it to run with commandline options
    return postfilter.RunWithCommandlineOptions(comlineargs)
#---------------------------------------------------------------------------









#-------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#-------------------------------------------------------------------------------


