#-------------------------------------------------------------------------------
# Name:        preprocess, sort
#-------------------------------------------------------------------------------
#!/usr/bin/env python






#-------------------------------------------------------------------------------
# imports we need
# include top level directory (needed to import from helper below)
import sys
import os
#-------------------------------------------------------------------------------



#-------------------------------------------------------------------------------
# add parent directory to path
curpath = os.path.dirname(os.path.realpath(__file__))
parpath = os.path.normpath(os.path.join(curpath, ".."))
sys.path.append(parpath)

# needed for sort helper
from operator import itemgetter

# import the parent classes
from TProcess import *
#-------------------------------------------------------------------------------


















#---------------------------------------------------------------------------
class TPreProcess_Sort(TProcess):

    def __init__(self):
        # parent init
        super(TPreProcess_Sort, self).__init__()

    def __del__(self):
        pass


    def ParseDerivedCommandlineArgs(self):
        self.helper.get_parser().add_option("", "--reverse", action="store_true", dest="reverse", help="if present this flag says to sort descending")
        # add target options
        self.helper.Handle_Target_ParseDerivedCommandlineArgs()
        pass


    def RunWithCommandlineOptions(self,comlineargs):
        # parse commandline using helper
        self.DoParseCommandline(comlineargs)
        # build extraargs
        extraargs = {}
        extraargs["reverse"]=self.helper.get_arg("reverse",False,False)
        # preprocess target options
        self.helper.Handle_Target_DoCommandlineOptionsProcess(extraargs,"LABEL")
        # run it
        retv = self.DoWork(self.helper.get_filein(),self.helper.get_fileout(),extraargs)
        return retv





    # overridden

    def DoFinishLines(self, outlines, extraargs):
        reverseflag=extraargs["reverse"]
        targetlist = extraargs["targetlist"]
        outlines.sort(key=lambda onelinedict: self.FunctionCallback_SortableFieldVal(onelinedict,targetlist),reverse=reverseflag)
        return outlines




    def FunctionCallback_SortableFieldVal(self, onelinedict,targetlist):
        sortvals = []
        for tl in targetlist:
            if (tl in onelinedict):
                sortvals.append(onelinedict[tl].lower())
        return sortvals
#---------------------------------------------------------------------------















































#---------------------------------------------------------------------------
def main(comlineargs=None):
    # make object
    processor = TPreProcess_Sort()

    # and ask it to run with commandline options
    return processor.RunWithCommandlineOptions(comlineargs)
#---------------------------------------------------------------------------









#-------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#-------------------------------------------------------------------------------


