#-------------------------------------------------------------------------------
# Name:        process, removeline
#-------------------------------------------------------------------------------
#!/usr/bin/env python






#-------------------------------------------------------------------------------
# imports we need
# include top level directory (needed to import from helper below)
import sys
import os
#-------------------------------------------------------------------------------



#-------------------------------------------------------------------------------
# add parent directory to path
curpath = os.path.dirname(os.path.realpath(__file__))
parpath = os.path.normpath(os.path.join(curpath, ".."))
sys.path.append(parpath)

# import the parent classes
from TProcess import *
#-------------------------------------------------------------------------------


















#---------------------------------------------------------------------------
class TProcess_RemoveLine(TProcess):

    def __init__(self):
        # parent init
        super(TProcess_RemoveLine, self).__init__()

    def __del__(self):
        pass


    def ParseDerivedCommandlineArgs(self):
        self.helper.get_parser().add_option("", "--scoremin", dest="scoremin", help="scores less than this will be removed")
        # add match options
        self.helper.Handle_Match_ParseDerivedCommandlineArgs()


    def RunWithCommandlineOptions(self,comlineargs):
        # parse commandline using helper
        self.DoParseCommandline(comlineargs)
        # build extraargs
        extraargs = {}
        extraargs["scoremin"]=int(self.helper.get_arg("scoremin","999999",False))
        # preprocess match options
        self.helper.Handle_Match_DoCommandlineOptionsProcess(extraargs)
        # run it
        retv = self.DoWork(self.helper.get_filein(),self.helper.get_fileout(),extraargs)
        return retv




    # overridden

    def DoProcessLineDict(self,linedict,extraargs):
        # manipulate the linedict in any way one wants

        # match check? we only continue if we match
        if (not self.helper.DoMatchTest_OnCompiledMatchArg(extraargs,linedict)):
            return linedict;

        # ok now the score
        if (extraargs["scoremin"]<999999):
            if ("score" in linedict):
                if (int(linedict["score"]) < extraargs["scoremin"]):
                    # delete it
                    return None
                # fine, keep it
                return linedict
            else:
                # no score in this entry but score passed on commandline, so keep it
                return linedict

        # no score on commandline, so if it matches match, remove it
        if (extraargs["match"]!=""):
            return None

        # keep it
        return linedict
#---------------------------------------------------------------------------















































#---------------------------------------------------------------------------
def main(comlineargs=None):
    # make object
    processor = TProcess_RemoveLine()

    # and ask it to run with commandline options
    return processor.RunWithCommandlineOptions(comlineargs)
#---------------------------------------------------------------------------









#-------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#-------------------------------------------------------------------------------


