#-------------------------------------------------------------------------------
# Name:        search
#-------------------------------------------------------------------------------
#!/usr/bin/env python






#-------------------------------------------------------------------------------
# imports we need
import sys
import os
#-------------------------------------------------------------------------------



#-------------------------------------------------------------------------------
# add parent directory to path
curpath = os.path.dirname(os.path.realpath(__file__))
parpath = os.path.normpath(os.path.join(curpath, ".."))
sys.path.append(parpath)

# import the parent classes
from search_rssos import TSearch_RssOs
#-------------------------------------------------------------------------------







#-------------------------------------------------------------------------------
# defines and constants
DEF_TSearch_GoogleApi_GoogleApiKey = ""
DEF_TSearch_GoogleApi_GoogleCx = "001099011188031881746:0kwviv5gwzc"

# some cx's to test on:
# donationcoder.com cx: 001099011188031881746:_kqigwsah-s
# entire web cx: 001099011188031881746:0kwviv5gwzc
#-------------------------------------------------------------------------------














#---------------------------------------------------------------------------
class TSearch_GoogleCustomApi(TSearch_RssOs):

    def __init__(self):
        # parent init
        super(TSearch_GoogleCustomApi, self).__init__()
        self.key=''

    def __del__(self):
        pass


    def get_searchenginename(self):
        return "core.googlecustomapi"


    def ParseDerivedCommandlineArgs(self):
        # parse any derived object specific commandline options
        self.helper.get_parser().add_option("", "--key", dest="key", help="required google api key")
        self.helper.get_parser().add_option("", "--cx", dest="cx", help="required google custom search id")
        pass


    def BuildSearchUrlFromSearchString(self,search):
        # build params
        self.key = self.helper.get_arg("key",DEF_TSearch_GoogleApi_GoogleApiKey,True)
        self.cx = self.helper.get_arg("cx",DEF_TSearch_GoogleApi_GoogleCx,False)
        params = "alt=atom&cx="+self.cx+"&q="+self.helper.urlquoteargs(search)
        # add api key
        if self.key!="":
            params += "&key=" + self.key
        # form url
        url = "https://www.googleapis.com/customsearch/v1?"+params
        # extra args?
        urlargs = self.helper.get_arg("urlargs","",False)
        if (urlargs!=""):
            url = url + "&"+urlargs
        #print "QUERY URL = "+url
        # return it
        return url

#---------------------------------------------------------------------------






























































































#---------------------------------------------------------------------------
def main(comlineargs=None):
    # make object

    searcher = TSearch_GoogleCustomApi()

    # and ask it to run with commandline options
    retcode = searcher.RunWithCommandlineOptions(comlineargs)

    return retcode
#---------------------------------------------------------------------------




#-------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#-------------------------------------------------------------------------------


